<template>
  <div>
    <GManageTable
      :card="card"
      :i18n-base="i18nBase"
      v-bind="$attrs"
      :headers="headers"
      :items="value.measuringEquipment"
      :get-new-item="getNewItem"
      :optional="optional"
      use-wrapper
      :wiki-entry="wikiEntry"
      @create="create"
      @edit="edit"
      @remove="remove"
      @deleteElement="$emit('delete')"
    >
      <template #form="{ item, updateAvailableElements }">
        <MeasuringEquipment
          v-model="item.value"
          :update-available-elements="updateAvailableElements"
        />
      </template>

      <template #[`item.name`]="{ item }">
        {{ getForCurrentLocale(item.name) }}
      </template>
      <template #[`item.description`]="{ item }">
        <div class="text-truncate default-max-width">
          {{ getForCurrentLocale(item.description) }}
        </div>
      </template>
    </GManageTable>
  </div>
</template>

<script>
import { MeasuringEquipmentType } from "@d-ptb/dcc-js";
import { validatableMixin } from "../../Mixins/validatableMixin";
import { removeFromArray } from "~/assets/util/general";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import MeasuringEquipment from "~/components/DCC/MeasurementResults/MeasuringEquipment";

export default {
  name: "MeasuringEquipmentList",
  components: {
    MeasuringEquipment,
    GManageTable,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    card: {
      type: Boolean,
      default: true,
    },
    optional: {
      type: Boolean,
      default: true,
    },
    i18nBase: {
      type: String,
      default: "dcc.common.measuringEquipmentListType",
    },
    wikiEntry: {
      type: String,
      default: "measuringEquipment",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.common.measuringEquipmentType.name"),
          value: "name",
        },
        {
          text: this.$t("dcc.common.richContentType.description.title"),
          value: "description",
        },
      ],
    };
  },
  computed: {
    customRules() {
      return [() => this.value.measuringEquipment.length > 0];
    },
  },
  watch: {
    "value.measuringEquipment"() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value.measuringEquipment, item);
    },
    create(item) {
      this.value.measuringEquipment.push(new MeasuringEquipmentType(item));
    },
    edit(item, index) {
      this.$set(this.value.measuringEquipment, index, undefined);
      this.$set(
        this.value.measuringEquipment,
        index,
        new MeasuringEquipmentType(item)
      );
    },
    getNewItem() {
      return new MeasuringEquipmentType();
    },
  },
};
</script>
